// File: test.cc
//
// Time-stamp: <31-Oct-2002 18:40:33 goetz>
// $Id: $
//
// Copyright (C) 2002 by Novel Science International
//
// Author: me
//
// Description: 
// 
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include <sys/types.h>
#include <limits.h>
#include <sys/fcntl.h>
#include <db1/db.h>
#include "agendaSync.h"


#define PDA_DATA_TYPE_ANZ 10
#define PDA_DATA_TYPE_FIELDS 8

#define PDA_DATA_CATEGORY_CSV_FIELD 0
typedef struct
{
 int id;
 char *tag;
} pdaDataTypes;

pdaDataTypes pdaDataType[PDA_DATA_TYPE_ANZ] =
 {
  { 0,   "other"},
  { 1,    "main"},
  { 2,    "home"},
  { 3,    "work"},
  { 4,     "fax"},
  { 5,   "e-mail"},
  { 6,  "mobile"},
  { 7,   "pager"},
  { 8,     "URL"},
  { 9, "Home-FAX"}
 };
int pdaTypeFieldList[PDA_DATA_TYPE_FIELDS] = {5,12,14,16,18,20,22,28};


//types )phone)
// 0=other 1=Main 2=Home  3=Work  4=FAX  5=E-Mail  6=Mobile  7=Pager  8=URL 9=Home Fax
//types (addr)
// 0 =other 1= main  2=Home  3=Work  

// contacts entry format
// Byte 1: status  (0x1 modified 0x2 deleted 0x4 private)
// Byte 2: categry
// Byte 3- list of 0x1F separate fields

// contacts fields:
//  0 First name
//  1 Last name 
//  2 ? company
//  3 ? title*
//  4 ?adr1 type
//  5 adr1 adr
//  6 adr1 city
//  7 ? adr1 state
//  8 adr1 zip
//  9 adr1 country
// 10 ?primFon      
// 11 ?fon1 type
// 12 fon1 
// 13 ?fon2 type
// 14 fon2
// 15 ?fon3 type
// 16 fon3
// 17 ?fon4 type
// 18 fon4
// 19 ?fon5 type
// 20 fon5
// 21 ?fon6 type
// 22 fon6
// 23 custom 1
// 24 custom 2
// 25 custom 3
// 26 custom 4
// 27 ? adr2 type
// 28 adr2 adr
// 29 adr2 city
// 30 ? adr2 state
// 31 adr2 zip
// 32 ? adr2 country
// 33 notes
// 34
// 35
// 36
// 37
// 38
// 39 minkoID


// special keys:
// 0xFFFFFFFF: category list
// 0xFEFFFFFF: version?
// 0xFFFFFFFE: version?

typedef struct 
{
 int agendaCol;
 int typeCol;
 int csvCol[16];
} csvColDef;


// Address assignement
//               1st         2nd
// home-addre    -> private  -> 2nd Addres  (ref by -10,... -14)
// main-address  ->1st Adr   -> 2ndAdr      (ref by -11)
// other-address ->1st Adr   -> 2ndAdr      (ref by -11)
// work-address  ->1st Adr   -> 2ndAdr      (ref by -11)

// Communication assigenment
//                1st   2nd    3rd          (ref by -1)
// other          1st   2nd    3rd          (ref by -1)
// main           1st   2nd    3rd          (ref by -1)
// home           priv  1st    2nd  3rd     (ref by -2)
// work           1st   2nd    3rd          (ref by -1)
// fax            fax1  faxP   -            (ref by -3)
// mail           mail1 mail2  mailP        (ref by -4)
// mobile         fon4                      = 22
// pager          1st   2nd    3rd          (ref by -1)
// url            www1  www2   -            (ref by -5)
// home-fax       faxP                      = 25

// CSV-format
//  0     1      2         3      4     5         6        7        8
// title name lastname  company adr1 adr1City Adr1State adr1Zip Adr1Country
//  9     10       11        12       13         14    15      16        17        18
// adr2 adr2City Adr2State adr2Zip Adr2Country  adrP adrPCity AdrPState adrPZip AdrPCountry
//  19   20   21   22   23   24   25   26    27    28     29  30   31    32    33 34 35  36      
// fon1 fon2 fon3 fon4 fonP fax1 faxP mail1 mail2 mailP  www wwwP info custom1  2  3  4  minkoID 
//  37         38        39         40         41        42     43   
// fon1-type fon2-type fon3-type fon4-type  adr1-type adr2-type cat 

// Minkowsky-format string:
// TITEL NAME_1 NAME_2 COMPA ADR1A CITY1 ADR1C PLZ1 CNTRY1  ADR2A CITY2 ADR2C PLZ2 CNTRY2 \
// ADR3A CITY3 ADR3C PLZ3 CNTRY3 FON1 FON2 FON3 FON4 FON_P FAX  FAX_P MAIL MAIL2 MAIL_P WWW WWWP INFO \
// CUSTOM1 CUSTOM2 CUSTOM3 CUSTOM4 IGNORE(FON1,0) IGNORE(FON2,0) IGNORE(FON3,0) IGNORE(FON4,0)  
// IGNORE(FON1,0) IGNORE(ADR1A,0) IGNORE(ADR2A,0) IGNORE(ADR3A,0) IGNORE

#define CSV_COL_DEFS 34
#define CSV_COLS     38
csvColDef agendaCols[CSV_COL_DEFS]= { 
 { 0,-1,{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 { 1,-1,{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 { 2,-1,{ 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 { 3,-1,{ 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 { 5, 4,{-20,-20,-10,-20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 { 6, 4,{-21,-21,-11,-21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 { 7, 4,{-22,-22,-12,-22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 { 8, 4,{-23,-23,-13,-23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 { 9, 4,{-24,-24,-14,-24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {12,11,{-1,-1,-1,-2,-1,-3,-4,22,-1,-5,25,-1,-1,-1,-1,0}},
 {14,13,{-1,-1,-1,-2,-1,-3,-4,22,-1,-5,25,-1,-1,-1,-1,0}},
 {16,15,{-1,-1,-1,-2,-1,-3,-4,22,-1,-5,25,-1,-1,-1,-1,0}},
 {18,17,{-1,-1,-1,-2,-1,-3,-4,22,-1,-5,25,-1,-1,-1,-1,0}},
 {20,19,{-1,-1,-1,-2,-1,-3,-4,22,-1,-5,25,-1,-1,-1,-1,0}},
 {22,21,{-1,-1,-1,-2,-1,-3,-4,22,-1,-5,25,-1,-1,-1,-1,0}},
 {23,-1,{32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {24,-1,{33, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {25,-1,{34, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {26,-1,{35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {28,27,{-20,-20,-10,-20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {29,27,{-21,-21,-11,-21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {30,27,{-22,-22,-12,-22, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {31,27,{-23,-23,-13,-23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {32,27,{-24,-24,-14,-24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {33,-1,{31, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {39,-1,{36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {39,-1,{36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {39,-1,{36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {39,-1,{36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {39,-1,{36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {39,-1,{36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {39,-1,{36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {39,-1,{36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}},
 {39,-1,{36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0}}
};
  

 
char *skip2NextSep(char *t,char sep);
char *skip2Next(char *t,char sep);
char *extractNext (char *t,char sep, char *dup);
void writeCsv(char *file ,agendaContacts *ac );
void writeCats(char *file ,agendaContacts *ac );
void readCsv(char *file,agendaContacts *ac ) ;
void contactsDB2mem ( char *file,agendaContacts *ac ) ;
void contactsMem2DB ( char *file,agendaContacts *ac ) ;
char * quoteQuotes(char *t);
char * unquoteQuotes(char *t);
char *endOfCsvEntry(char *t);
int getCategoryNumber(char *s1, agendaContacts *ac);
int str2PDAtype(char *t);
char * pdaType2str(int type);
void printUsage ();
void dumpDB ( char *file);

#define WITHOUT_PDA

int main(int argc, char *argv[])
{
 // char *pool_file="/home/goetz/agenda/mySync/contacts.dat";
 char pool_file[1024];
 char txt[40][256];
 char dev[256];
 char cmd[1024];
 char buf[64];
 int direction;
 char file[1024];
 FILE *fp;
 agendaContacts agenda;
 int i,j;
 int localIP = 0xC0A80101;
 int remoteIP = 0xC0A80104;
 char catFile [1024];
 int onlyLocal=false;
 int doConnect=false;
 int disconnectOnEnd=false;
 char *dir;
 int inOutOptions =0;
 if(argc <2)
  {
   printUsage();
  }

 dir = argv[1];
 if( strcmp(dir,"open") == 0)
  {
   if(argc < 5)  printUsage ();
   strcpy(dev,argv[2]);
   localIP  = str2IP(argv[3]);
   remoteIP = str2IP(argv[4]);
  }
 else if ( strcmp(dir,"analyse") == 0)
  {
   if(argc < 3)  printUsage ();
   strcpy(file,argv[2]);
  }
  else if ( strcmp(dir,"dump") == 0)
  {
   if(argc < 3)  printUsage ();
   strcpy(file,argv[2]);
  }
else if ( strcmp(dir,"in") == 0)
  {
   strcpy(catFile,argv[3]);   if(argc < 4)  printUsage ();
   strcpy(file,argv[2]);

   if(argc>4)
    inOutOptions=4;
  }
 else if ( strcmp(dir,"out") == 0)
  {
   if(argc < 3)  printUsage ();
   strcpy(file,argv[2]);
   if(argc>3)
    inOutOptions=3;
  }
 else if ( strcmp(dir,"close") == 0)
  {
   ;
  }
 else if ( strcmp(dir,"check") == 0)
  {
   ;
  }
 else
  printUsage();

 if(inOutOptions >0)
  {
   int ac=inOutOptions;
   while(ac<argc)
    {
     if(strcmp(argv[ac],"-d")==0)
      disconnectOnEnd=true;
     else if(strcmp(argv[ac],"-l")==0)
      onlyLocal =true;
     else if(strcmp(argv[ac],"-c")==0)
      {
       doConnect = true;
       strcpy(dev,argv[ac+1]);
       localIP  = str2IP(argv[ac+2]);
       remoteIP = str2IP(argv[ac+3]);
       ac+=3;
      }
     ac++;
    }
  }
 if(onlyLocal)
  doConnect = false;




 if( strcmp(dir,"open") == 0)
  {
   contactAgenda(dev,localIP,remoteIP,true);
   exit(0);
  }
 else if ( strcmp(dir,"close") == 0)
  {
   if(readConnectionData(&pdc))
    close_pppd();
   exit(0);
  }
 else if ( strcmp(dir,"check") == 0)
  {
   int err;
   if(!readConnectionData(&pdc))
    exit(-1);
   if(!checkConnection(&pdc,"contacts.dat",&err))
    exit(err);
   exit(0);
  }
 else if( strcmp(dir,"analyse") == 0)
  {
   agenda.colAnz =40;
   contactsDB2mem(file,&agenda);
   writeCsv("ana.csv",&agenda);
  }
 else if( strcmp(dir,"dump") == 0)
  {
   agenda.colAnz =40;
   dumpDB(file);
   writeCsv("ana.csv",&agenda);
  }
 else if( strcmp(dir,"in") == 0)
  {
   //   pool_file = "/home/goetz/agenda/mySync/contacts.in.dat";
   sprintf(pool_file,"/tmp/agendaSync%05d-contacts.in.dat",getpid());
   if(!onlyLocal)
    {
     contactAgenda(dev,localIP,remoteIP,doConnect);
     rsyncIn("contacts.dat",pool_file);
    }
   agenda.colAnz =40;
   contactsDB2mem(pool_file,&agenda);
   writeCsv(file,&agenda);
   if(catFile[0] == '\0')
    sprintf(catFile,"%s.cat",file);
   writeCats(catFile ,&agenda ); 
   printf("csv written\n");
   if(!onlyLocal)
    if(disconnectOnEnd)
     close_pppd();
   unlink(pool_file);
  }
 if( strcmp(dir,"out") == 0)
  {
   sprintf(pool_file,"/tmp/agendaSync%05d-contacts.out.dat",getpid());
   //   pool_file = "/home/goetz/agenda/mySync/contacts.out.dat";
   agenda.colAnz =40;
   readCsv(file,&agenda);
   writeCsv("/home/goetz/agenda/mySync/contacts.tst.dat",&agenda);
   contactsMem2DB(pool_file,&agenda);
   
   if(!onlyLocal)
    {
     contactAgenda(dev,localIP,remoteIP,doConnect);
     rsyncOut("contacts.dat",pool_file);
     if(disconnectOnEnd)
      close_pppd();
    }
   unlink(pool_file);
  }
}
void printUsage ()
{
 printf("\n");
 printf("usage: AgendaCal operation (parameters)\n\n");
 printf("Operations:\n");
 printf("            open     : Open Connection to Agenda\n");
 printf("            in       : Sync Data into Desktop from Agenda\n");
 printf("            out      : Sync Data out of Desktop to Agenda\n");
 printf("            close    : Closes the coenction to the Agenda\n");
 printf("            check    : Checks the coenction to the Agenda\n");
 printf("Syntax:\n");
 printf("       agendaContacts open device  localIP remoteIP\n");
 printf("       agendaContacts in csv-file cat-file [options] \n");
 printf("       agendaContacts out csv-file  [options] \n"); 
 printf("       agendaContacts close\n");
 printf("       agendaContacts check\n");
 printf("\n");
 printf("Options:\n");
 printf(" -c device  localIP remoteIP :  Connect before\n");
 printf(" -d                          :  Diconnect after operation\n");
 printf(" -l                          :  Work on local file rather rsyncing the PDA\n");
 exit(-1);
}


int contactAgenda(char *dev,int localIP, int remoteIP,int connect)
{

 if(connect)
  {
   if(! init_pppd(&pdc,dev,localIP,remoteIP))
    {
     printf("Can't init connection\n");
     exit(-2);
    }
   if( ! start_pppd(&pdc))
    {
     printf("Can't init connection (2)\n");
     exit(-3);
    }
  }
 else
  {
   if(!readConnectionData(&pdc))
    exit (-1);
  }
}

int str2IP(char *str)
{
 char c[64];
 int ip=0;
 int i;
 char *t,*s;

 strncpy(c,str,63);
 c[64]='\0';
 
 t=c;
 for(i=0;i<4; i++)
  {
   s=strchr(t,'.');
   if(s!=NULL)
    *s='\0';
   else
    {
     if(i!=3)
      {
       return 0;
      }
    }
   ip = (ip<<8) + atoi(t);
   t=s+1;
  }
 // printf("'%s' -> %08X\n",str,ip);
 return (ip);
}

void readCsv(char *file,agendaContacts *ac ) 
{
 FILE *fp;
 int e,count,i;
 char *t;
 char line[65536];

 fp = fopen(file,"r");
 if(fp == NULL)
  {
   fprintf(stderr,"Can't open %s\n",file);
   exit(-3);
  }

 printf("reading %s\n",file);
 count=0;
 while( (t= fgets(line,65535,fp) ) != NULL)
   count ++ ;
 printf("%d lines\n",count);

 ac->entry = new agendaContactsEntry [count +2];
 ac->entryAnz = count;

 ac->cat[0] = new char [8];
 strcpy(ac->cat[0],"Others");
 ac->maxCat=0;

 rewind(fp);
 e=0;
 while( (t= fgets(line,65535,fp) ) != NULL)
  {
   
   ac->entry[e].csv = unsplitCsv(t,ac->colAnz,',');
   ac->entry[e].cat = getCategoryNumber(unquoteSpecialChars(ac->entry[e].csv->col[0],','),ac);
   for(i=0;i<ac->entry[e].csv->cols; i++)
    if(ac->entry[e].csv->col[i] == NULL)
     {
      ac->entry[e].csv->col[i] = new char[2];
      ac->entry[e].csv->col[i][0] = '\0';
     }
   e++;
  }
 printf("csv read (%d entries; %d categories)\n",e,ac->maxCat);
}

void writeCsv(char *file ,agendaContacts *ac ) 
{
 FILE *fp;
 int i;
 char *buffer=NULL;

 fp = fopen(file,"w");
 if(fp == NULL)
  {
   fprintf(stderr,"Can't open %s\n",file);
   exit(-3);
  }
 for( i =0 ; i<ac->entryAnz ; i++)
  { // i
   buffer = concatCsv(ac->entry[i].csv,',');
   fprintf(fp,"%s\n",buffer);
   delete buffer;
  }
 fclose(fp);
}
void writeCats(char *file ,agendaContacts *ac ) 
{
 FILE *fp;
 int i;
 char *buffer=NULL;

 fp = fopen(file,"w");
 if(fp == NULL)
  {
   fprintf(stderr,"Can't open %s\n",file);
   exit(-3);
  }
 for( i =0 ; i<=ac->maxCat ; i++)
  if(ac->cat[i] != NULL)
   {
    printf("%s ---->  %s\n",ac->cat[i],unquoteSpecialChars(ac->cat[i] ,','));
    fprintf(fp,"%s\n",unquoteSpecialChars(ac->cat[i] ,','));;
   }
 fclose(fp);
}



void contactsMem2DB ( char *file,agendaContacts *ac ) 
{
 DB *pdbp;
 DBT pkey, pcontent;
 int aid=0;
 int i,j;
 char buf[65526],kbuf[64],*t;
 unsigned int *ky;
 int status;
 char sep='\x1f',sep2='\x1e';
 char *uqs;
 int e;

 pdbp = dbopen(file, O_CREAT | O_TRUNC | O_RDWR, 0664, DB_HASH, NULL);
 if(!pdbp) {
  perror("dbopen:");
  printf("error 11\n");
  exit(-1);
 }
 printf("DB open %p\n",pdbp);

 memset(kbuf,0,63);
 ky = (unsigned int *) kbuf;
 pkey.data = (void *) kbuf;
 pkey.size = 4;
 for( e =0 ; e<ac->entryAnz ; e++)
  {
   
   for(i=0;i<PDA_DATA_TYPE_FIELDS; i++)
    {
     int fnr = pdaTypeFieldList[i];
     if(ac->entry[e].csv->col[fnr][0] != '\0')
      {
       int typ =  str2PDAtype(ac->entry[e].csv->col[fnr]);
       delete ac->entry[e].csv->col[fnr];
       ac->entry[e].csv->col[fnr] = NULL;
       allocateAndCopy(ac->entry[e].csv,fnr,typ);
      }
    }
   printf("writing %d/%d\n",e,ac->entryAnz);
   *ky = aid;
   memset(buf,0,65535);
   pcontent.data=(void *) buf;
   buf[0] = 0;
   buf[1] = (char ) (ac->entry[e].cat & 0xFF);
   t=buf+2;
   for(j=0;j<ac->colAnz ; j++)
    {
     if(j == PDA_DATA_CATEGORY_CSV_FIELD)
      continue;
     strcpy(t,ac->entry[e].csv->col[j]);
     t += strlen(ac->entry[e].csv->col[j]);
     *t=sep;
     t++;
    }
   t[-1]='\0';

   pcontent.size = t-buf;
   printf("adding to DB\n");
   if( (status = pdbp->put(pdbp, &pkey, &pcontent, 0)) != 0)
    {
     printf("Error write to DB at entry %d status=%d\n",i,status);
     exit(-1);
    }
   printf("adding to DB done\n");
   aid++;
  }

 printf("adding categories\n");
 *ky = 0xFFFFFFFF;
 memset(buf,0,65535);
 pcontent.data=(void *) buf;
 buf[0] = 0; // correct
 buf[1] = 0; // correct
 t=buf+2;
 for(i=1;i<=ac->maxCat;i++)
  {
   char txt[1024],*uqc;
   int l;
   
   sprintf(txt,"%1X%c%1X%c%s%c",i,sep,0,sep,ac->cat[i],sep2);
   printf("%2d: '%s' -> '%s'\n",i,ac->cat[i],txt+4);
   l =strlen(ac->cat[i])+5;
   memcpy(t,txt,l);
   t+=l;
  }
 pcontent.size = t-buf;
 if( (status = pdbp->put(pdbp, &pkey, &pcontent, 0)) != 0)
  {
   printf("Error write to DB at entry %d status=%d\n",i,status);
   exit(-1);
  }

 pdbp->close(pdbp);
 printf("writing db done\n");
}

void contactsDB2mem ( char *file,agendaContacts *ac ) 
{
 DB *pdbp;
 DBT pkey, pcontent;
 int status,c=0;
 char buf[65536],kbuf[65536],*t,dup[65536],dup2[256],*s;
 char sep='\x1f',sep2='\x1e';
 unsigned int *ky;
 int i,e;
 char *t2,*s2;
 int id,l;
 int maxCat;
 char *tmp=NULL;
 int tmpLen=0;

 pdbp = dbopen(file, O_RDONLY, 0664, DB_HASH, NULL);
 if(!pdbp) {
  printf("error 1\n");
  exit(-1);
 }
 
 ky=(unsigned int *) kbuf;
 memset(kbuf,0,65535);
 *ky=0xFFFFFFFF;
 status = pdbp->seq(pdbp, &pkey, &pcontent,R_CURSOR);


 for(i=0;i<256; i++)
  ac->cat[i]=NULL;

 // Count line and get categories
 int count=0;
 for(int status = pdbp->seq(pdbp, &pkey, &pcontent, R_FIRST); 
     status == 0; 
     status = pdbp->seq(pdbp, &pkey, &pcontent, R_NEXT)) 
  {
   memset(kbuf,0,64);
   memcpy(kbuf,pkey.data,pkey.size);
   kbuf[pkey.size] ='\0';
   ky   = (unsigned int *) kbuf;
   if (*ky == 0xFFFFFFFF)
    {
     printf("got Categories\n");
     maxCat = 0;
     memset(buf,0,65535);
     memcpy( buf,pcontent.data,pcontent.size);
     buf[pcontent.size] ='\0';
     t =buf+2;
     while(t != NULL)
      {
       s  = extractNext(t,sep2,dup);
       t2 = s;
       s2 = extractNext(t2,sep,dup2);
       id = xtoi(dup2);
       t2 = skip2Next(t2,sep);
       t2 = skip2Next(t2,sep);
       if(t2 !=NULL)
	{
	 printf("cat %2d: %s  (%p)\n",id,t2,ac->cat[id]);
	 allocateAndCopy(&ac->cat[id],t2);
	 if(id>maxCat)
	  maxCat=id;
	}
       t = skip2Next(t,sep2);
       i++;
      }
    }
   else if(*ky != 0xFEFFFFFF && *ky != 0xFFFFFFFE )
    count ++;
  }
 if(ac->cat[0] == NULL)
  {
   ac->cat[0] = new char [8];
   strcpy(ac->cat[0],"Others");
  }

 printf("Categories:\n\t%3d = 'Others'\n",0);
 ac->maxCat =maxCat;
 for(i =1;i<=ac->maxCat; i++)
  if(ac->cat[i] != NULL)
   printf("\t%3d = '%s'\n",i,ac->cat[i]);


 ac->entry = new agendaContactsEntry [count +2];
 ac->entryAnz = count;

 int cs=0;
 e=0;
 for(int status = pdbp->seq(pdbp, &pkey, &pcontent, R_FIRST); 
     status == 0; 
     status = pdbp->seq(pdbp, &pkey, &pcontent, R_NEXT)) 
  {
   t =(char *)pcontent.data;
   if( ( t[0] & 4) == 4)
    {
     cs++;
     continue;
    }
   memset(kbuf,0,65535);
   memcpy(kbuf,pkey.data,pkey.size);
   kbuf[pkey.size] ='\0';

   ky   = (unsigned int *) kbuf;
   if(*ky == 0xFEFFFFFF || *ky == 0xFFFFFFFE || *ky == 0xFFFFFFFF )
     continue;
   
   ac->entry[e].cat = (int)t[1];
   ac->entry[e].csv = newCsvDataStruct( ac->colAnz);
   
   t+=2;
   s = skip2NextSep(t,sep);
   c=1;
   while(s != NULL)
    {
     *s='\0';
     //allocateAndCopy(ac->entry[e].csv,c,quoteSpecialChars( t,','));
     allocateAndCopy(ac->entry[e].csv,c,t);
     *s=sep;
     t=s+1;
     if(*t !='\0')
      s = skip2NextSep(t,sep);
     else
      s=NULL;
     c++;
     if(c>=ac->colAnz)
      break;
    }
   
   id = ac->entry[e].cat ;
   if( ac->cat[id] == NULL)
    id=0;
   allocateAndCopy(ac->entry[e].csv,0, ac->cat[id]);

   for(i=0;i<PDA_DATA_TYPE_FIELDS; i++)
    {
     char *typ;
     int fnr = pdaTypeFieldList[i];
     if(ac->entry[e].csv->col[fnr] != NULL)
      {
       typ = pdaType2str (atoi(ac->entry[e].csv->col[fnr]));
       delete ac->entry[e].csv->col[fnr];
       ac->entry[e].csv->col[fnr] = NULL;
       allocateAndCopy(ac->entry[e].csv,fnr,typ);
      }
    }    


   for(i=0;i<ac->entry[e].csv->cols; i++)
    if(ac->entry[e].csv->col[i] == NULL)
     {
      ac->entry[e].csv->col[i] = new char[2];
      ac->entry[e].csv->col[i][0] = '\0';
     }

   printf("%3d: %s %s : %d cols\n",e,ac->entry[e].csv->col[1],ac->entry[e].csv->col[2],ac->entry[e].csv->cols);

   e++;
   printf(".");
   fflush(stdout);
   if( (e % 50) == 0)
    printf("\n");
  }
 printf("\n");
 printf("%d/%d (%d) records read\n",e,ac->entryAnz,cs);
 
}


void dumpDB ( char *file) 
{
 DB *pdbp;
 DBT pkey, pcontent;
 int status,c=0;
 char buf[65536],kbuf[65536],*t,dup[65536],dup2[256],*s;
 char sep='\x1f',sep2='\x1e';
 unsigned int *ky;
 int i,e=0;
 char *t2,*s2;
 int id,l;
 int maxCat;
 char *tmp=NULL;
 int tmpLen=0;
 int cs=0;

 pdbp = dbopen(file, O_RDONLY, 0664, DB_HASH, NULL);
 if(!pdbp) {
  printf("error 1\n");
  exit(-1);
 }
 
 ky=(unsigned int *) kbuf;
 memset(kbuf,0,65535);
 *ky=0xFFFFFFFF;
 status = pdbp->seq(pdbp, &pkey, &pcontent,R_CURSOR);
 
 
 
 int count=0;
 for(int status = pdbp->seq(pdbp, &pkey, &pcontent, R_FIRST); 
     status == 0; 
     status = pdbp->seq(pdbp, &pkey, &pcontent, R_NEXT)) 
  {
   t =(char *)pcontent.data;
   memset(kbuf,0,65535);
   memcpy(kbuf,pkey.data,pkey.size);
   kbuf[pkey.size] ='\0';
   ky   = (unsigned int *) kbuf;
   
   printf("%4d: %08X  %6d:",e,*ky,pcontent.size);
   for(int i=0;i<pcontent.size; i++)
    if(t[i]<32 )
     printf(" 0x%02X ",t[i]);
    else
     putchar(t[i]);
   printf("\n");

   t+=2;
   s = skip2NextSep(t,sep);
   c=1;
   while(s != NULL)
    {
     *s='\0';
     printf("\t\t%3d: '%s'\n",c,t);
     *s=sep;
     t=s+1;
     if(*t !='\0')
      s = skip2NextSep(t,sep);
     else
      s=NULL;
     c++;
    }
   if(*t !='\0')
    printf("\t\t%3d: '%s'\n",c,t);

   e++;
  }
 printf("\n");
 printf("%d records read\n",e);
 
}

char *skip2NextSep(char *t,char sep)
{
 char *s;

 if (t==NULL)
  return NULL;

 if( (s= strchr(t,sep)) == NULL)
  return NULL;
   
 return s;
}

char *skip2Next(char *t,char sep)
{
 char *s;

 if (t==NULL)
  return NULL;

 if( (s= strchr(t,sep)) == NULL)
  return NULL;
   
 return s+1;
}
char *extractNext (char *t,char sep, char *dup)
{
 char *s;
 int l;

 dup[0]='\0';
 if (t==NULL)
  return dup;
 
 s = strchr(t,sep);
 if (s == NULL)
  return dup;

 l=s-t;
 strncpy(dup,t,l);
 dup[l]='\0';
 return(dup);
}
int getCategoryNumber(char *s1, agendaContacts *ac)
{
 int cn;
 for(cn=0;cn<=ac->maxCat;cn++)
  if(ac->cat[cn] != NULL)
   if(strcmp(ac->cat[cn],s1) == 0 )
    return(cn);

 ac->maxCat++;
 ac->cat[ac->maxCat] =  new char [strlen(s1)+1];
 strcpy(ac->cat[ac->maxCat],s1);
 printf("new category: id=%3d name='%s'\n",ac->maxCat,s1);
 return(ac->maxCat);
}

int str2PDAtype(char *t)
{
 for (int i =0 ; i<PDA_DATA_TYPE_ANZ ; i++)
  if(strcasecmp(t,pdaDataType[i].tag)==0)
   return(pdaDataType[i].id);
 return 0;
}

char * pdaType2str(int type)
{
 for (int i =0 ; i<PDA_DATA_TYPE_ANZ ; i++)
  if(pdaDataType[i].id == type)
   return(pdaDataType[i].tag);
 return "";
}
