#!/usr/bin/tclsh
# File: split.tcl
# Time-stamp: <15-Mar-2003 10:46:27 goetz>
# $Id: $
#
# Copyright (C) 2003 by Novel Science International
#
# Author: Ruediger Goetz
#
# Description: 


set inFile [lindex $argv 0]
set csvFile [lindex $argv 1]
set catFile [lindex $argv 2]
set sep     [lindex $argv 3 ]
set catCol  [lindex $argv 4]

array unset cats
set cats(Other) "Other"

if { [ file exists $inFile] } {
    exec mv $inFile $inFile.bak
    exec cat $inFile.bak | tr -d "\r" > $inFile

    set fid [open $inFile "r" ]
    set csv [open $csvFile "w" ]
    

    while { ! [eof $fid ] } {
	
	set line [gets $fid]
	set list [split $line $sep]
	puts $csv $line
	set cat [string trim [ string trim [lindex $list $catCol ] '\" ] ]
	set cats($cat) cat
    }
    close $csv
    close $fid
} else {
    exec touch $inFile
    exec touch $csvFile
}

set fid [open $catFile "w"]
puts [array names cats]
foreach cat [array names cats] {
    if { $cat != "" } {
	puts $cat
	puts $fid $cat
    }
}
close $fid
