/* File: client.h
 *
 *     This file is part of minkowsky
 *
 *     Copyright (C) 2001-2002 by Rdiger Goetz
 *     Author: Rdiger Goetz <minkowsky@r-goetz.de>
 *
 *     Time-stamp: <07-Jul-2003 20:22:08 goetz>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>  
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <unistd.h>  
#include <errno.h>    
#include <netinet/in.h>  
#include <netdb.h>

#ifdef _MINKO_CLIENT_MAIN
#define _M_EXTERN
#else
#define _M_EXTERN extern
#endif


#define EOT_OFFSET 4

#ifdef MACOSX
#	include <pthread.h>
#	include "tk.h"
#	include "tclInt.h"
#	include <tix.h>
#	include "locale.h"

//#	include <Carbon/Carbon.h>
//#	include "tkMacOSX.h"
//#	include "tkMacOSXEvent.h"

#	ifndef MAX_PATH_LEN
#		define MAX_PATH_LEN 1024
#	endif

#else
#	include <tcl.h>
#	include <tk.h>
#	include <tix.h>
#	include <time.h>     
#	include <signal.h>
#	include <sys/poll.h>  
#	include <X11/Xlib.h>
#endif

#define MAX_CLIENTS 1000
#ifndef MASTERPORT
#define MASTERPORT  41999
#endif
 



// main.cc
char *nextElement(char *t);
char *skip2NonWS(char*t);
char * strTrim (char *t);

// tcl.cc
void startTCL (int argc, char *argv[] );
int initTclFunctions (Tcl_Interp *interp);
int logIntoServer(ClientData cData, Tcl_Interp *interp, int argc,const char *argv[]);
int closeConnect(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int send2Server(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int getAnswer(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int checkServer(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int closeApp(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int getTag(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int getBinPath(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int getTclBinPath(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int setTagList(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int matchString(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);

//tcl-plattform.cc
int initApsh(Tcl_Interp *interp);
int weekDayByDate(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int weekDayByDateStr(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int currentTime(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int currentDateTime(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int timeBetween(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);
int mouseStatus(ClientData cData, Tcl_Interp *interp, int argc,const  char *argv[]);


// comm-plattform.cc
void   initSockets();
char * logIntoServer(char *curUserName, char *curPasswd, int reconnect );
int    openSocket(char *master,int port);
int    send2Socket(int socket,char *msg);
int    send2DamagedSocket(int socket,char *msg);
int    wait4Message(int socket, char *buffer,int len, int timeout);
int    send2Server(char *cmd, char *buffer, int bufLen);
int    getAnswer(char **buffer, const char * ticket);
char * checkServer();
int    closeSocket ();
void closeApp(int value);


// int send2Socket(int socket,char *msg);
// int send2DamagedSocket(int socket,char *msg);
// int openSocket(char *host,int port);
// int wait4Message(int socket, char *buffer,int len, int timeout);
// void startTCL (int argc, char *argv[] );
// int initApsh(Tcl_Interp *interp);
// int send2Server(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int send2Server(char *cmd, char *buffer, int bufLen);
// int getAnswer(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int getAnswer(char **buffer, char * ticket);
// int checkServer(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int weekDayByDate(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int weekDayByDateStr(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int currentTime(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int currentDateTime(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int timeBetween(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int setTagList(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int getTag(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int getBinPath(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int getTclBinPath(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int mouseStatus(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int closeSocket ();
// int closeApp(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// void closeApp(int val);
// void gotData(int val);
// void setGotData(int);

// void pipebroken(int val);
// #ifdef MACOSX 
//  int mouseStatus(void);g
// #endif
// int matchString(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// char *nextElement(char *t);
// char *skip2NonWS(char*t);
// int logIntoServer(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);
// int closeConnect(ClientData cData, Tcl_Interp *interp, int argc, char *argv[]);

// int cl_logIntoServer();
// int transfer(char *buffer,char **inp);
// char * strTrim (char *t);
// void cleanMessagePipe(int socket);

_M_EXTERN int mySocket;
_M_EXTERN char binPath[1024];
_M_EXTERN char terminHost[256];
_M_EXTERN char tclBinPath[1024];
_M_EXTERN char curUserName[32], curPasswd[32];


_M_EXTERN char tclMsg[16384];
_M_EXTERN int verbose;
typedef struct
{
 int x0,y0,x1,y1;
 char tag[64];
}canvasTags;

_M_EXTERN canvasTags *canvasList[8];
_M_EXTERN int canvasListLength[8];
_M_EXTERN int autoInstallMRR;
_M_EXTERN int enableSync;
_M_EXTERN int startGUI;
_M_EXTERN char cmdFile[1024],command[16384];
_M_EXTERN int cmdFromFile;
_M_EXTERN char username[256];
_M_EXTERN char password[256];

#define MSG_BUFFER_LEN 16384

_M_EXTERN char globalBuffer[500000];
_M_EXTERN FILE *fpl;

#ifdef NO_POLL
_M_EXTERN struct sigaction sigioAction;// = {NULL,setGotData,0,SA_SIGINFO,NULL};
_M_EXTERN int dataAvailable;
_M_EXTERN int timerStopped;
#endif
