/* File: tcl-unixX11.cc
 *
 *     This file is part of minkowsky
 *
 *     Copyright (C) 2001-2002 by Rdiger Goetz
 *     Author: Rdiger Goetz <minkowsky@r-goetz.de>
 *
 *     Time-stamp: <27-Oct-2002 15:52:40 goetz>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "../client.h"

// Functions in this module used outside the module:
//
// int initApsh(Tcl_Interp *interp)
// int mouseStatus(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])


int initApsh(Tcl_Interp *interp)
{

 if (Tcl_Init(interp) == TCL_ERROR) {
  return TCL_ERROR;
 }
 if (Tk_Init(interp) == TCL_ERROR) {
  return TCL_ERROR;
 }
 
#ifdef NOTSKIP
 Tcl_MacOSXOpenBundleResources (interp, "com.tcltk.tklibrary", 
				1, MAX_PATH_LEN, tkLibPath);
 
 /* 
  * FIXME: This is currently a hack...  I set the tcl_library, and
  * tk_library, but apparently that's not enough to get slave interpreters,
  * even unsafe ones, to find the library code.  They seem to ignore 
  * this and look at the var set in TclGetLibraryPath.  So I override
  * that here.  There must be a better way to do this!
  */
 
 if (tclLibPath[0] != '\0') {
  pathPtr = Tcl_NewStringObj(tclLibPath, -1);
 } else {
  pathPtr = TclGetLibraryPath();
 }
 
 if (tkLibPath[0] != '\0') {
  Tcl_Obj *objPtr;
  
  Tcl_SetVar(interp, "tk_library", tkLibPath, TCL_GLOBAL_ONLY);
  objPtr = Tcl_NewStringObj(tkLibPath, -1);
  Tcl_ListObjAppendElement(NULL, pathPtr, objPtr);
 }
 
 TclSetLibraryPath(pathPtr);
#endif

 if (Tix_Init(interp) == TCL_ERROR) {
  return TCL_ERROR;
 }
 if(!initTclFunctions (interp))
  return TCL_ERRO;

 return TCL_OK;
}


int mouseStatus(ClientData cData, Tcl_Interp *interp, int argc, char *argv[])
{

 sprintf(interp->result,"%d",mouseStatus());
 return(TCL_OK);
}
